use bitvec::{order::Msb0, view::BitView};

const WIDTH: usize = 96;
//const HEIGHT: usize = 38;

#[no_mangle]
pub extern "C" fn next_frame(frame: u16, ptr: *mut u8) -> u8 {
    let out = unsafe { std::slice::from_raw_parts_mut(ptr, 456) }.view_bits_mut::<Msb0>();

    if frame > 100 {
        return 1;
    }

    let cat = include_bytes!(concat!(env!("OUT_DIR"), "/cat.bin")).view_bits::<Msb0>();

    for x in 0..96 {
        for y in 0..38 {
            let out_idx = index(x, y);
            let in_idx = index((x - frame as usize * 4) % WIDTH, y);

            out.set(out_idx, cat[in_idx]);
        }
    }

    0
}

fn index(x: usize, y: usize) -> usize {
    x + y * WIDTH
}
